package graph.output.graph;



import java.awt.*;


import javax.swing.*;


import org.jgraph.JGraph;
import org.jgrapht.*;
import org.jgrapht.ext.*;

import org.jgrapht.graph.*;

import entity.DOProcess;
import entity.Entity;

/**
 * A demo applet that shows how to use JGraph to visualize JGraphT graphs.
 *
 * @author Barak Naveh
 * @since Aug 3, 2003
 */
public class JGraphOutput    extends JApplet
{
    //~ Static fields/initializers ---------------------------------------------

    private static final long serialVersionUID = 3256444702936019250L;
    private static final Color DEFAULT_BG_COLOR = Color.decode("#FAFBFF");
    private static final Dimension DEFAULT_SIZE = new Dimension(800, 800);

    //~ Instance fields --------------------------------------------------------

    //
    private JGraphModelAdapter<Entity, DOProcess> jgAdapter;

    //~ Methods ----------------------------------------------------------------

    /**
     * An alternative starting point for this demo, to also allow running this
     * applet as an application.
     *
     * @param args ignored.
     */
    public JGraphOutput(UndirectedGraph<Entity, DOProcess> graph)
    {
    	
        this.init(graph);

        JFrame frame = new JFrame();
        frame.getContentPane().add(this);
        frame.setTitle("JGraphT Adapter to JGraph Demo");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.pack();
        frame.setVisible(true);
    }

    /**
     * {@inheritDoc}
     */
    public void init(UndirectedGraph<Entity, DOProcess> graph)
    { 
        // create a JGraphT graphq
        ListenableGraph<Entity, DOProcess> g =new ListenableUndirectedGraph<Entity, DOProcess>(graph);

        // create a visualization using JGraph, via an adapter
        jgAdapter =  new JGraphModelAdapter<Entity,DOProcess>(g);
        
        JGraph jgraph = new JGraph(jgAdapter);

        adjustDisplaySettings(jgraph);
        getContentPane().add(jgraph);
        resize(DEFAULT_SIZE);
       
     
    }

    private void adjustDisplaySettings(JGraph jg)
    {
        jg.setPreferredSize(DEFAULT_SIZE);

        Color c = DEFAULT_BG_COLOR;
        String colorStr = null;

        try {
            colorStr = getParameter("bgcolor");
        } catch (Exception e) {
        }

        if (colorStr != null) {
            c = Color.decode(colorStr);
        }

        jg.setBackground(c);
    }

//    @SuppressWarnings("unchecked") // FIXME hb 28-nov-05: See FIXME below
//    private void positionVertexAt(Object vertex, int x, int y)
//    {
//        DefaultGraphCell cell = jgAdapter.getVertexCell(vertex);
//        AttributeMap attr = cell.getAttributes();
//        Rectangle2D bounds = GraphConstants.getBounds(attr);
//
//        Rectangle2D newBounds = new Rectangle2D.Double(x,y,bounds.getWidth(),bounds.getHeight());
//
//        GraphConstants.setBounds(attr, newBounds);
//
//        // TODO: Clean up generics once JGraph goes generic
//        org.jgraph.graph.AttributeMap cellAttr = new AttributeMap();
//        cellAttr.put(cell, attr);
//        jgAdapter.edit(cellAttr, null, null, null);
//    }


}
