package graph.output.screen;


import java.util.List;

import org.graphstream.graph.Graph;
import org.graphstream.graph.Node;
import org.graphstream.graph.implementations.SingleGraph;

import entity.DOProcess;
import entity.Judge;
import entity.Lawyer;
import entity.TYPES;
import graph.output.OutPutFactory;

public class ScreenOutput extends OutPutFactory{


	protected String styleSheet =
			"node {" +
					"	fill-color: black;" +
					"}" +
					"node.marked {" +
					"	fill-color: red;" +
					"}";

	protected Graph graph;

	public ScreenOutput() {
		graph = new SingleGraph("Processos X Juizes");

		graph.addAttribute("ui.stylesheet", styleSheet);
		graph.setAutoCreate(true);
		graph.setStrict(false);
		graph.display();


	}



	@Override
	public void insertToOutPut(DOProcess process) {


		if(process.getJudges().size() > 0)
		{

			Judge judge = process.getJudge();
			if(!judge.getName().equals(TYPES.NAMEDEFAULT))
			{
				Node judgeNode;

				if( graph.getNode(judge.getName()) == null )
				{
					judgeNode = graph.addNode(judge.getName());
					judgeNode.setAttribute("ui.class", "marked");
					judgeNode.addAttribute("ui.label", judge.getName());

				}
				else
				{
					judgeNode = graph.getNode(judge.getName());
				}

				Integer ID = new Integer(0);
				for(Lawyer laywer: process.getLawyer())
				{


					if(!laywer.getName().equals(TYPES.NAMEDEFAULT))
					{

						Node lawyerNode;
						if( graph.getNode(laywer.getName()) == null )
						{
							lawyerNode= graph.addNode(laywer.getName());
							lawyerNode.addAttribute("ui.label", laywer.getName());

						}
						else
						{
							lawyerNode= graph.getNode(laywer.getName());

						}

						graph.addEdge(process.getProcessNumber()+ID.toString(), judgeNode, lawyerNode);
						ID++;

					}



				}
			}
		}




	}
	
	
	

	
	
	




	@Override
	public void buildOutput(List<DOProcess> allProcess) {

		for( DOProcess process : allProcess )
		{
			try {
				if(process.getVerdict().length() > 100)	
				{
					//System.out.println(process.getVerdict());
					this.insertToOutPut(process);
					Thread.sleep(300);
					System.out.println(process.getVerdict());
				}
				else
				{
					//System.out.println(process.getVerdict());
				}

			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}


		}


	}







	@Override
	public void print() {
		// TODO Auto-generated method stub

	}



}
